#[doc = "Register `STATUS_CH_ACT` reader"]
pub struct R(crate::R<STATUS_CH_ACT_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<STATUS_CH_ACT_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<STATUS_CH_ACT_SPEC>> for R {
    fn from(reader: crate::R<STATUS_CH_ACT_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `STATUS_CH_ACT` writer"]
pub struct W(crate::W<STATUS_CH_ACT_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<STATUS_CH_ACT_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<STATUS_CH_ACT_SPEC>> for W {
    fn from(writer: crate::W<STATUS_CH_ACT_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `CH` reader - Channel activation status. Bit i is associated to channel i, with i = 0, ?, CH_NR-1.??Software reads this field to get information on all actively pending channels (either in pending or in the data transfer engine)."]
pub struct CH_R(crate::FieldReader<u32, u32>);
impl CH_R {
    pub(crate) fn new(bits: u32) -> Self {
        CH_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for CH_R {
    type Target = crate::FieldReader<u32, u32>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:31 - Channel activation status. Bit i is associated to channel i, with i = 0, ?, CH_NR-1.??Software reads this field to get information on all actively pending channels (either in pending or in the data transfer engine)."]
    #[inline(always)]
    pub fn ch(&self) -> CH_R {
        CH_R::new((self.bits & 0xffff_ffff) as u32)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Channel activation status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [status_ch_act](index.html) module"]
pub struct STATUS_CH_ACT_SPEC;
impl crate::RegisterSpec for STATUS_CH_ACT_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [status_ch_act::R](R) reader structure"]
impl crate::Readable for STATUS_CH_ACT_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [status_ch_act::W](W) writer structure"]
impl crate::Writable for STATUS_CH_ACT_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets STATUS_CH_ACT to value 0"]
impl crate::Resettable for STATUS_CH_ACT_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
